commit 93452c4195f32af2148b916f280e1c1a7b4294fc
Author: A-Konig <alex-nebulae@seznam.cz>
Date:   Mon Apr 12 18:28:40 2021 +0200

    Simple parser - missing comments, code needed asap

diff --git a/Server/ServerApp/Parser/Parsers/CsvParser.cs b/Server/ServerApp/Parser/Parsers/CsvParser.cs
new file mode 100644
index 0000000..aef6b80
--- /dev/null
+++ b/Server/ServerApp/Parser/Parsers/CsvParser.cs
@@ -0,0 +1,64 @@
+﻿using Parser.OutputInfo;
+using System;
+using System.Collections.Generic;
+using System.Globalization;
+using System.Threading;
+
+namespace Parser.Parsers
+{
+    class CsvParser
+    {
+
+        string path;
+        WeatherParser weatherParser;
+        JisParser jisParser;
+        LogInParser loginParser;
+
+        public CsvParser()
+        {
+            TagInfo.CreateDictionaries();
+            path = "data/";
+
+            weatherParser = new WeatherParser();
+            jisParser = new JisParser();
+            loginParser = new LogInParser();
+        }
+
+        public void Parse()
+        {
+            var cultureInfo = CultureInfo.GetCultureInfo("en-GB");
+            Thread.CurrentThread.CurrentCulture = cultureInfo;
+            Thread.CurrentThread.CurrentUICulture = cultureInfo;
+
+            string pathWeather = path + "weather";
+            string pathJis = path + "jis";
+            string pathLogIn = path + "login";
+
+
+            List<WeatherInfo> weatherList = weatherParser.ParseWeatherData(pathWeather);
+            List<JisInfo> jisList = jisParser.ParseJisData(pathJis);
+            List<LogInInfo> loginList = loginParser.ParseLogInData(pathLogIn);
+
+            Console.WriteLine("WEATHER");
+            WriteToConsole(weatherList);
+            Console.WriteLine("JIS");
+            WriteToConsole(jisList);
+            Console.WriteLine("LOGIN");
+            WriteToConsole(loginList);
+        }
+
+        private void WriteToConsole<T>(List<T> list)
+        {
+            if (list == null)
+            {
+                Console.WriteLine("Unsuccessful parsing");
+                return;
+            }
+            Console.WriteLine(list.Count);
+
+            for (int i = 0; i < list.Count; i++)
+                Console.WriteLine(list[i].ToString());
+        }
+
+    }
+}
diff --git a/Server/ServerApp/Parser/Parsers/LogInParser.cs b/Server/ServerApp/Parser/Parsers/LogInParser.cs
index 43f1059..6e9a505 100644
--- a/Server/ServerApp/Parser/Parsers/LogInParser.cs
+++ b/Server/ServerApp/Parser/Parsers/LogInParser.cs
@@ -54,7 +54,7 @@ namespace Parser.Parsers
             DateTime lastStartDay = new DateTime(list[0].date.Year, list[0].date.Month, list[0].date.Day);
             for (int i = 0; i < list.Count; i++)
             {
-                int currHour = list[i].date.Hour;
+                int currHour = list[i].lessonStart.Hour;
                 if (currHour < minmaxHour[0] || currHour > minmaxHour[1])
                     continue;
 
diff --git a/Server/ServerApp/Parser/Parsers/WeatherParser.cs b/Server/ServerApp/Parser/Parsers/WeatherParser.cs
index 420536c..9c40a61 100644
--- a/Server/ServerApp/Parser/Parsers/WeatherParser.cs
+++ b/Server/ServerApp/Parser/Parsers/WeatherParser.cs
@@ -65,9 +65,6 @@ namespace Parser.Parsers
                 DateTime date = new DateTime(list[i].dateTime.Year, list[i].dateTime.Month, list[i].dateTime.Day);
                 if (!date.Equals(lastStartDay))
                 {
-                    Console.WriteLine(values);
-                    Console.WriteLine(recordedAmount[0]);
-
                     WeatherInfo dayInfo = new WeatherInfo(lastStartDay, recordedAmount[0] / values, (int)(recordedAmount[1] / values * 100), recordedAmount[2] / values, recordedAmount[3] / values, range); 
                     weatherInfo.Add(dayInfo);
 
diff --git a/Server/ServerApp/Program.cs b/Server/ServerApp/Program.cs
index 7428139..d4a834b 100644
--- a/Server/ServerApp/Program.cs
+++ b/Server/ServerApp/Program.cs
@@ -1,9 +1,9 @@
-﻿using Parser.OutputInfo;
-using Parser.Parsers;
+﻿using Parser.Parsers;
 using System;
 using System.Collections.Generic;
-using System.Globalization;
-using System.Threading;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
 
 namespace ServerApp
 {
@@ -11,25 +11,9 @@ namespace ServerApp
     {
         static void Main(string[] args)
         {
-            var cultureInfo = CultureInfo.GetCultureInfo("en-GB");
-            Thread.CurrentThread.CurrentCulture = cultureInfo;
-            Thread.CurrentThread.CurrentUICulture = cultureInfo;
+            CsvParser p = new CsvParser();
 
-            TagInfo.CreateDictionaries();
-
-            string path = "data/weather/";
-            
-            WeatherParser parser = new WeatherParser();
-            List<WeatherInfo> list = parser.ParseWeatherData(path);
-            if (list == null)
-                Console.WriteLine("Unsuccessful parsing");
-
-            Console.WriteLine(list.Count);
-
-            for (int i = 0; i < list.Count; i++)
-            {
-                Console.WriteLine(list[i].ToString());
-            }
+            p.Parse();
 
             Console.ReadLine();
         }
diff --git a/Server/ServerApp/Properties/AssemblyInfo.cs b/Server/ServerApp/Properties/AssemblyInfo.cs
index e5f2f59..76b7e53 100644
--- a/Server/ServerApp/Properties/AssemblyInfo.cs
+++ b/Server/ServerApp/Properties/AssemblyInfo.cs
@@ -5,11 +5,11 @@ using System.Runtime.InteropServices;
 // General Information about an assembly is controlled through the following
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
-[assembly: AssemblyTitle("Parser 1.0")]
+[assembly: AssemblyTitle("ServerApp")]
 [assembly: AssemblyDescription("")]
 [assembly: AssemblyConfiguration("")]
 [assembly: AssemblyCompany("")]
-[assembly: AssemblyProduct("Parser 1.0")]
+[assembly: AssemblyProduct("ServerApp")]
 [assembly: AssemblyCopyright("Copyright ©  2021")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -20,7 +20,7 @@ using System.Runtime.InteropServices;
 [assembly: ComVisible(false)]
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("916c1e8a-0d6d-43fb-8bde-dbedf441842d")]
+[assembly: Guid("b49b2821-751c-4032-8637-b4e9282dcf06")]
 
 // Version information for an assembly consists of the following four values:
 //
diff --git a/Server/ServerApp/ServerApp.csproj b/Server/ServerApp/ServerApp.csproj
index b0b0c49..63a1a07 100644
--- a/Server/ServerApp/ServerApp.csproj
+++ b/Server/ServerApp/ServerApp.csproj
@@ -4,10 +4,10 @@
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProjectGuid>{916C1E8A-0D6D-43FB-8BDE-DBEDF441842D}</ProjectGuid>
+    <ProjectGuid>{B49B2821-751C-4032-8637-B4E9282DCF06}</ProjectGuid>
     <OutputType>Exe</OutputType>
-    <RootNamespace>Parser_1._0</RootNamespace>
-    <AssemblyName>Parser 1.0</AssemblyName>
+    <RootNamespace>ServerApp</RootNamespace>
+    <AssemblyName>ServerApp</AssemblyName>
     <TargetFrameworkVersion>v4.7.2</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
@@ -43,17 +43,19 @@
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="obj\Debug\.NETFramework,Version=v4.7.2.AssemblyAttributes.cs" />
     <Compile Include="Parser\InputData\CsvDataLoader.cs" />
-    <Compile Include="Parser\InputData\WeatherInstance.cs" />
-    <Compile Include="Parser\OutputInfo\JisInfo.cs" />
     <Compile Include="Parser\InputData\JisInstance.cs" />
     <Compile Include="Parser\InputData\LogInInstance.cs" />
+    <Compile Include="Parser\InputData\WeatherInstance.cs" />
+    <Compile Include="Parser\OutputInfo\JisInfo.cs" />
     <Compile Include="Parser\OutputInfo\LogInInfo.cs" />
     <Compile Include="Parser\OutputInfo\LumInfo.cs" />
     <Compile Include="Parser\OutputInfo\RainInfo.cs" />
     <Compile Include="Parser\OutputInfo\TempInfo.cs" />
     <Compile Include="Parser\OutputInfo\WeatherInfo.cs" />
     <Compile Include="Parser\OutputInfo\WindInfo.cs" />
+    <Compile Include="Parser\Parsers\CsvParser.cs" />
     <Compile Include="Parser\Parsers\JisParser.cs" />
     <Compile Include="Parser\Parsers\LogInParser.cs" />
     <Compile Include="Parser\Parsers\TagInfo.cs" />
@@ -108,6 +110,13 @@
     <None Include="data\weather\OD_ZCU_POCASI_12_2019.CSV">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </None>
+    <None Include="obj\Debug\DesignTimeResolveAssemblyReferencesInput.cache" />
+    <None Include="obj\Debug\ServerApp.csprojAssemblyReference.cache" />
+  </ItemGroup>
+  <ItemGroup>
+    <Folder Include="bin\Debug\" />
+    <Folder Include="bin\Release\" />
+    <Folder Include="obj\Debug\TempPE\" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
 </Project>
\ No newline at end of file
diff --git a/Server/ServerApp/ServerApp.csproj.user b/Server/ServerApp/ServerApp.csproj.user
new file mode 100644
index 0000000..9b86104
--- /dev/null
+++ b/Server/ServerApp/ServerApp.csproj.user
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="Current" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <ProjectView>ShowAllFiles</ProjectView>
+  </PropertyGroup>
+</Project>
\ No newline at end of file
diff --git a/Server/ServerApp/bin/Debug/Parser 1.0.exe b/Server/ServerApp/bin/Debug/Parser 1.0.exe
deleted file mode 100644
index 9053022..0000000
Binary files a/Server/ServerApp/bin/Debug/Parser 1.0.exe and /dev/null differ
diff --git a/Server/ServerApp/bin/Debug/Parser 1.0.exe.config b/Server/ServerApp/bin/Debug/Parser 1.0.exe.config
deleted file mode 100644
index 56efbc7..0000000
--- a/Server/ServerApp/bin/Debug/Parser 1.0.exe.config	
+++ /dev/null
@@ -1,6 +0,0 @@
-﻿<?xml version="1.0" encoding="utf-8" ?>
-<configuration>
-    <startup> 
-        <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.7.2" />
-    </startup>
-</configuration>
\ No newline at end of file
diff --git a/Server/ServerApp/bin/Debug/Parser 1.0.pdb b/Server/ServerApp/bin/Debug/Parser 1.0.pdb
deleted file mode 100644
index 322ceeb..0000000
Binary files a/Server/ServerApp/bin/Debug/Parser 1.0.pdb and /dev/null differ
diff --git a/Server/ServerApp/bin/Debug/ServerApp.exe b/Server/ServerApp/bin/Debug/ServerApp.exe
new file mode 100644
index 0000000..fc6e2a8
Binary files /dev/null and b/Server/ServerApp/bin/Debug/ServerApp.exe differ
diff --git a/Server/ServerApp/bin/Debug/ServerApp.exe.config b/Server/ServerApp/bin/Debug/ServerApp.exe.config
new file mode 100644
index 0000000..56efbc7
--- /dev/null
+++ b/Server/ServerApp/bin/Debug/ServerApp.exe.config
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8" ?>
+<configuration>
+    <startup> 
+        <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.7.2" />
+    </startup>
+</configuration>
\ No newline at end of file
diff --git a/Server/ServerApp/bin/Debug/ServerApp.pdb b/Server/ServerApp/bin/Debug/ServerApp.pdb
new file mode 100644
index 0000000..2a61eb6
Binary files /dev/null and b/Server/ServerApp/bin/Debug/ServerApp.pdb differ
diff --git a/Server/ServerApp/obj/Debug/DesignTimeResolveAssemblyReferencesInput.cache b/Server/ServerApp/obj/Debug/DesignTimeResolveAssemblyReferencesInput.cache
index d241ba1..50cd1a9 100644
Binary files a/Server/ServerApp/obj/Debug/DesignTimeResolveAssemblyReferencesInput.cache and b/Server/ServerApp/obj/Debug/DesignTimeResolveAssemblyReferencesInput.cache differ
diff --git a/Server/ServerApp/obj/Debug/Parser 1.0.csproj.CoreCompileInputs.cache b/Server/ServerApp/obj/Debug/Parser 1.0.csproj.CoreCompileInputs.cache
deleted file mode 100644
index 1e42a39..0000000
--- a/Server/ServerApp/obj/Debug/Parser 1.0.csproj.CoreCompileInputs.cache	
+++ /dev/null
@@ -1 +0,0 @@
-6dd7f2ce22534de52176bab0244f6bb4c66a26cb
diff --git a/Server/ServerApp/obj/Debug/Parser 1.0.csproj.FileListAbsolute.txt b/Server/ServerApp/obj/Debug/Parser 1.0.csproj.FileListAbsolute.txt
deleted file mode 100644
index 4ac5f75..0000000
--- a/Server/ServerApp/obj/Debug/Parser 1.0.csproj.FileListAbsolute.txt	
+++ /dev/null
@@ -1,22 +0,0 @@
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\Parser 1.0.exe.config
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\Parser 1.0.exe
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\Parser 1.0.pdb
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\Parser 1.0.csprojAssemblyReference.cache
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\Parser 1.0.csproj.CoreCompileInputs.cache
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\Parser 1.0.exe
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\Parser 1.0.pdb
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_06_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_09_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_10_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_11_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_12_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_06_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_09_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_10_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_11_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_12_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_06_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_09_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_10_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_11_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_12_2019.CSV
diff --git a/Server/ServerApp/obj/Debug/Parser 1.0.csprojAssemblyReference.cache b/Server/ServerApp/obj/Debug/Parser 1.0.csprojAssemblyReference.cache
deleted file mode 100644
index 797d988..0000000
Binary files a/Server/ServerApp/obj/Debug/Parser 1.0.csprojAssemblyReference.cache and /dev/null differ
diff --git a/Server/ServerApp/obj/Debug/Parser 1.0.exe b/Server/ServerApp/obj/Debug/Parser 1.0.exe
deleted file mode 100644
index 9053022..0000000
Binary files a/Server/ServerApp/obj/Debug/Parser 1.0.exe and /dev/null differ
diff --git a/Server/ServerApp/obj/Debug/Parser 1.0.pdb b/Server/ServerApp/obj/Debug/Parser 1.0.pdb
deleted file mode 100644
index 322ceeb..0000000
Binary files a/Server/ServerApp/obj/Debug/Parser 1.0.pdb and /dev/null differ
diff --git a/Server/ServerApp/obj/Debug/ServerApp.csproj.CoreCompileInputs.cache b/Server/ServerApp/obj/Debug/ServerApp.csproj.CoreCompileInputs.cache
index 4bb452b..0811323 100644
--- a/Server/ServerApp/obj/Debug/ServerApp.csproj.CoreCompileInputs.cache
+++ b/Server/ServerApp/obj/Debug/ServerApp.csproj.CoreCompileInputs.cache
@@ -1 +1 @@
-94fc4d50c54ee91ff047ff0b1ed88c2837fd975a
+446e0a8c9360f09ce5d918714762c9add41796cd
diff --git a/Server/ServerApp/obj/Debug/ServerApp.csproj.FileListAbsolute.txt b/Server/ServerApp/obj/Debug/ServerApp.csproj.FileListAbsolute.txt
index 102b3d3..dd46cee 100644
--- a/Server/ServerApp/obj/Debug/ServerApp.csproj.FileListAbsolute.txt
+++ b/Server/ServerApp/obj/Debug/ServerApp.csproj.FileListAbsolute.txt
@@ -1,25 +1,10 @@
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_06_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_09_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_10_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_11_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\jis\OD_ZCU_JIS_12_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_06_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_09_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_10_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_11_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\login\OD_ZCU_STROJE_12_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_06_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_09_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_10_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_11_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\data\weather\OD_ZCU_POCASI_12_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\Parser 1.0.exe.config
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\Parser 1.0.exe
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\bin\Debug\Parser 1.0.pdb
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\ServerApp.csprojAssemblyReference.cache
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\ServerApp.csproj.CoreCompileInputs.cache
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\Parser 1.0.exe
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\Parser 1.0\obj\Debug\Parser 1.0.pdb
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\ServerApp.exe.config
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\ServerApp.exe
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\ServerApp.pdb
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\ServerApp.csprojAssemblyReference.cache
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\ServerApp.csproj.CoreCompileInputs.cache
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\ServerApp.exe
+D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\ServerApp.pdb
 D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\data\jis\OD_ZCU_JIS_06_2019.CSV
 D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\data\jis\OD_ZCU_JIS_09_2019.CSV
 D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\data\jis\OD_ZCU_JIS_10_2019.CSV
@@ -35,10 +20,3 @@ D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-m
 D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\data\weather\OD_ZCU_POCASI_10_2019.CSV
 D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\data\weather\OD_ZCU_POCASI_11_2019.CSV
 D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\data\weather\OD_ZCU_POCASI_12_2019.CSV
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\Parser 1.0.exe.config
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\Parser 1.0.exe
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\bin\Debug\Parser 1.0.pdb
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\ServerApp.csprojAssemblyReference.cache
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\ServerApp.csproj.CoreCompileInputs.cache
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\Parser 1.0.exe
-D:\moje\school\04\aswi\sem\open data\Develop\aswi2021tri-musketyri\aswi2021tri-musketyri\Server\ServerApp\obj\Debug\Parser 1.0.pdb
diff --git a/Server/ServerApp/obj/Debug/ServerApp.csprojAssemblyReference.cache b/Server/ServerApp/obj/Debug/ServerApp.csprojAssemblyReference.cache
index 0e98c86..8b2ee19 100644
Binary files a/Server/ServerApp/obj/Debug/ServerApp.csprojAssemblyReference.cache and b/Server/ServerApp/obj/Debug/ServerApp.csprojAssemblyReference.cache differ
diff --git a/Server/ServerApp/obj/Debug/ServerApp.exe b/Server/ServerApp/obj/Debug/ServerApp.exe
new file mode 100644
index 0000000..fc6e2a8
Binary files /dev/null and b/Server/ServerApp/obj/Debug/ServerApp.exe differ
diff --git a/Server/ServerApp/obj/Debug/ServerApp.pdb b/Server/ServerApp/obj/Debug/ServerApp.pdb
new file mode 100644
index 0000000..2a61eb6
Binary files /dev/null and b/Server/ServerApp/obj/Debug/ServerApp.pdb differ