commit 9fb55c71802343d12fe75925472dfbbc6dc21e87
Author: A-Konig <alex-nebulae@seznam.cz>
Date:   Fri May 14 16:11:54 2021 +0200

    re #8840 Update commit - start/endTime in method Parse in DataParser can now be null

diff --git a/Server/ServerApp/Parser/Parsers/DataParser.cs b/Server/ServerApp/Parser/Parsers/DataParser.cs
index 48bd17a..5313953 100644
--- a/Server/ServerApp/Parser/Parsers/DataParser.cs
+++ b/Server/ServerApp/Parser/Parsers/DataParser.cs
@@ -67,19 +67,24 @@ namespace ServerApp.Parser.Parsers
         /// <param name="startTime">Start time of related data</param>
         override public bool Parse(DateTime startTime, DateTime endTime, int interval = 1, bool wholeDay = true)
         {
-
             var cultureInfo = CultureInfo.GetCultureInfo("en-GB");
             Thread.CurrentThread.CurrentCulture = cultureInfo;
             Thread.CurrentThread.CurrentUICulture = cultureInfo;
 
             // get path to folder w/ datafiles
-            string pathWeather = downloader.DataSubDirectories[DataType.POCASI]; // path + "weather";
-            string pathJis = downloader.DataSubDirectories[DataType.JIS]; // path + "jis";
-            string pathLogIn = downloader.DataSubDirectories[DataType.STROJE]; // path + "login";
+            string pathWeather = downloader.DataSubDirectories[DataType.POCASI];
+            string pathJis = downloader.DataSubDirectories[DataType.JIS];
+            string pathLogIn = downloader.DataSubDirectories[DataType.STROJE];
 
             // get all files that should be parsed
-            Date start = new Date((uint)startTime.Month, (uint)startTime.Year);
-            Date end = new Date((uint)endTime.Month, (uint)endTime.Year);
+            Date start = null;
+            Date end = null;
+            if (startTime != null || endTime != null)
+            {
+                start = new Date((uint)startTime.Month, (uint)startTime.Year);
+                end = new Date((uint)endTime.Month, (uint)endTime.Year);
+            }
+
             var weatherFiles = downloader.GetData(pathWeather, start, end);
             var jisFiles = downloader.GetData(pathJis, start, end);
             var loginFiles = downloader.GetData(pathLogIn, start, end);
@@ -90,8 +95,8 @@ namespace ServerApp.Parser.Parsers
 
             //Console.WriteLine("WEATHER");
             //WriteToConsole(weatherList);
-            Console.WriteLine("JIS");
-            WriteToConsole(jisList);
+            //Console.WriteLine("JIS");
+            //WriteToConsole(jisList);
             //Console.WriteLine("LOGIN");
             //WriteToConsole(loginList);
 
@@ -99,8 +104,8 @@ namespace ServerApp.Parser.Parsers
 
             MergeAttendance();
 
-            Console.WriteLine("MERGED IN ONE LIST");
-            WriteToConsole(attendanceList);
+            //Console.WriteLine("MERGED IN ONE LIST");
+            //WriteToConsole(attendanceList);
 
             if (weatherList.Count == 0 || attendanceList.Count == 0)
                 return false;
diff --git a/Server/ServerApp/ServerApp.csproj b/Server/ServerApp/ServerApp.csproj
index 1ca848d..ae3f3b6 100644
--- a/Server/ServerApp/ServerApp.csproj
+++ b/Server/ServerApp/ServerApp.csproj
@@ -166,11 +166,13 @@
     <Compile Include="Parser\InputData\LogInInstance.cs" />
     <Compile Include="Parser\InputData\WeatherInstance.cs" />
     <Compile Include="Parser\OutputInfo\ActivityInfo.cs" />
+    <Compile Include="Parser\OutputInfo\ValueToConditions.cs" />
     <Compile Include="Parser\OutputInfo\WeatherConditions.cs" />
     <Compile Include="Parser\OutputInfo\WeatherInfo.cs" />
     <Compile Include="Parser\Parsers\DataParser.cs" />
     <Compile Include="Parser\Parsers\IDataParser.cs" />
     <Compile Include="Parser\Parsers\JisParser.cs" />
+    <Compile Include="WeatherPredictionParser\IJsonParser.cs" />
     <Compile Include="WeatherPredictionParser\JsonParser.cs" />
     <Compile Include="Parser\Parsers\LogInParser.cs" />
     <Compile Include="Parser\Parsers\TagInfo.cs" />
diff --git a/Server/ServerApp/WeatherPredictionParser/JsonParser.cs b/Server/ServerApp/WeatherPredictionParser/JsonParser.cs
index e9a7c42..45b912b 100644
--- a/Server/ServerApp/WeatherPredictionParser/JsonParser.cs
+++ b/Server/ServerApp/WeatherPredictionParser/JsonParser.cs
@@ -87,7 +87,6 @@ namespace ServerApp.WeatherPredictionParser
                             current = ParseCurrentWeather(currentWeather);
 
                             break;
-
                         }
                     // weather prediction
                     case "weather":
@@ -103,7 +102,7 @@ namespace ServerApp.WeatherPredictionParser
             // sunrise + sunset into data
             EncompassSunRiseSetTimes();
 
-            TestConsoleOutput();
+            //TestConsoleOutput();
         }
 
         /// <summary>