commit a65830914d1ce35eebcae15da47fc7a912333d16
Author: A-Konig <alex-nebulae@seznam.cz>
Date:   Fri Apr 23 20:32:29 2021 +0200

    re #8682 Changed tags

diff --git a/Server/ServerApp/Parser/Parsers/TagInfo.cs b/Server/ServerApp/Parser/Parsers/TagInfo.cs
index 77dff8f..e4facbc 100644
--- a/Server/ServerApp/Parser/Parsers/TagInfo.cs
+++ b/Server/ServerApp/Parser/Parsers/TagInfo.cs
@@ -1,5 +1,7 @@
 ﻿using System.Collections.Generic;
 
+// 30min
+
 namespace ServerApp.Parser.Parsers
 {
     /// <author>Alex Konig</author>
@@ -20,113 +22,165 @@ namespace ServerApp.Parser.Parsers
 
             // FACULTIES
 
-            faculties = new string[] { "FST", "FEK", "FEL", "FDU", "FF", "FPE", "FEK-CH", "FZS", "FAV", "FPR" };
+         faculties = new string[] { "FST+FEK", "FDU", "FAV", "FEL", "REK", "MENZA", "LIB", "CIV", "UNI14", "DOM", "HUS", "CHOD", "JUNG", "KLAT", "KOLL", "RIEG", "SADY", "SED+VEL", "TES",
+                                    "TYL", "KARMA", "KBORY", "KLOCH", "KKLAT" };
 
             // BUILDING TAGS
 
-            buildingTags.Add("UV", -2);
-            buildingTags.Add("UU", -2);
-            buildingTags.Add("UK", -2);
-            buildingTags.Add("UL", -2);
-            buildingTags.Add("UP", -2);
-            buildingTags.Add("UF", -2);
-
+            // FST+FEK
+            buildingTags.Add("UV", 0);
+            buildingTags.Add("UU", 0);
+            buildingTags.Add("UK", 0);
+            buildingTags.Add("UL", 0);
+            buildingTags.Add("UP", 0);
+            buildingTags.Add("UF", 0);
             buildingTags.Add("UT", 0);
+            buildingTags.Add("UH", 0);
+            buildingTags.Add("UD", 0);
+            buildingTags.Add("UX", 0);
 
-            buildingTags.Add("EU", 2);
-            buildingTags.Add("EK", 2);
-            buildingTags.Add("EL", 2);
-            buildingTags.Add("EP", 2);
-            buildingTags.Add("ES", 2);
-            buildingTags.Add("ET", 2);
-            buildingTags.Add("EH", 2);
-            buildingTags.Add("EZ", 2);
+            // FDU
+            buildingTags.Add("LS", 1);
 
-            buildingTags.Add("LS", 3);
+            // FAV
+            buildingTags.Add("UN", 2);
+            buildingTags.Add("UC", 2);
+            buildingTags.Add("US", 2);
 
-            buildingTags.Add("JJ", 4);
-            buildingTags.Add("RJ", 4);
-            buildingTags.Add("RS", 4);
-            buildingTags.Add("SP", 4);
-            buildingTags.Add("SD", 4);
-            buildingTags.Add("ST", 4);
-            buildingTags.Add("SO", 4);
+            // FEL
+            buildingTags.Add("EU", 3);
+            buildingTags.Add("EK", 3);
+            buildingTags.Add("EL", 3);
+            buildingTags.Add("EP", 3);
+            buildingTags.Add("ES", 3);
+            buildingTags.Add("ET", 3);
+            buildingTags.Add("EH", 3);
+            buildingTags.Add("EZ", 3);
 
-            buildingTags.Add("CH", 5);
-            buildingTags.Add("VC", 5);
-            buildingTags.Add("KL", 5);
+            // REK
+            buildingTags.Add("UR", 4);
 
-            buildingTags.Add("CD", 6);
+            // MENZA
+            // 5
 
-            buildingTags.Add("HJ", 7);
-            buildingTags.Add("DD", 7);
+            // LIB
+            buildingTags.Add("UB", 6);
 
-            buildingTags.Add("UN", 8);
-            buildingTags.Add("UC", 8);
-            buildingTags.Add("US", 8);
+            // CIV
+            buildingTags.Add("UI", 7);
 
-            buildingTags.Add("PC", 9);
-            buildingTags.Add("PS", 9);
+            // UNI14
+            buildingTags.Add("UT", 8);
 
-            buildingTags.Add("UI", -1);
-            buildingTags.Add("UB", -1);
+            // DOM
+            buildingTags.Add("DD", 9);
 
-            // JIS PLACES
+            // HUS
+            buildingTags.Add("HJ", 10);
 
-            jisPlaces.Add("A1", -1);
-            jisPlaces.Add("A2-Hlavni vchod", -1);
-            jisPlaces.Add("A3", -1);
-            jisPlaces.Add("B3-LEVY", -1);
-            jisPlaces.Add("M16", -1);
-            jisPlaces.Add("M14", -1);
-            jisPlaces.Add("L1", -1);
-            jisPlaces.Add("L2", -1);
-            jisPlaces.Add("L1L2-vchod", -1);
-            jisPlaces.Add("Zavora-Kaplirova", -1);
-            jisPlaces.Add("KolaBory-vnejsi", -1);
-            jisPlaces.Add("KolaBory-vnitrni", -1);
-            jisPlaces.Add("Parkoviste-vjezd", -1);
-            jisPlaces.Add("Parkoviste-vyjezd", -1);
-            jisPlaces.Add("B3-kolarna", -1);
-            jisPlaces.Add("MenzaKL-vydej", -1);
-            jisPlaces.Add("Menza4-kasa1", -1);
-            jisPlaces.Add("Menza4-kasa2", -1);
-            jisPlaces.Add("Menza4-kasa3", -1);
-            jisPlaces.Add("Menza4-kasa4", -1);
-            jisPlaces.Add("Menza4-kasa5", -1);
-            jisPlaces.Add("Menza-kasa-1", -1);
-            jisPlaces.Add("Menza-kasa-p", -1);
-            jisPlaces.Add("Menza1-kasa-p", -1);
-            jisPlaces.Add("Menza1-kasa-l", -1);
-            jisPlaces.Add("STUD_UB113", -1);
-            jisPlaces.Add("STUD_UB211", -1);
-
-            jisPlaces.Add("Zavora-FEL", 2);
-            jisPlaces.Add("US 005 - závora vjezd", 8);
-            jisPlaces.Add("US 005 - mříž vjezd", 8);
-            jisPlaces.Add("Zavora-NTIS-vjezd", 8);
-            jisPlaces.Add("Zavora-NTIS-vyjezd", 8);
-            jisPlaces.Add("EXT/kola-B", 8);
-            jisPlaces.Add("NTIS-BUFET", 8);
-
-            jisPlaces.Add("Zavora-FDU", 3);
-
-            jisPlaces.Add("VC-VJEZD", 5);
-            jisPlaces.Add("VC-VYJEZD", 5);
-            jisPlaces.Add("STUD_VC53", 5);
-            jisPlaces.Add("STUD_KL20", 5);
-            jisPlaces.Add("STUD_KL87", 5);
+            // CHOD
+            buildingTags.Add("CH", 11);
 
-            jisPlaces.Add("EXT/kola", 0);
+            // JUNG
+            buildingTags.Add("JJ", 12);
 
-            jisPlaces.Add("EP-BUFET", 2);
+            // KLAT
+            buildingTags.Add("KL", 13);
 
-            jisPlaces.Add("UV1-Bufet", 1);
+            // KOLL
+            buildingTags.Add("KO", 14);
 
-            jisPlaces.Add("STUD_CHEB", 6);
+            // RIEG
+            buildingTags.Add("RJ", 15);
+            buildingTags.Add("RS", 15);
 
-            jisPlaces.Add("STUD_PRA1", 9);
+            // SADY
+            buildingTags.Add("PC", 16);
+            buildingTags.Add("PS", 16);
+
+            // SED+VEL
+            buildingTags.Add("SP", 17);
+            buildingTags.Add("SD", 17);
+            buildingTags.Add("ST", 17);
+            buildingTags.Add("SO", 17);
+            buildingTags.Add("VC", 17);
+
+            // TES
+            buildingTags.Add("T", 18);
+            buildingTags.Add("TF", 18);
+            buildingTags.Add("TG", 18);
+            buildingTags.Add("TH", 18);
 
+            // TYL
+            buildingTags.Add("TY", 19);
+            buildingTags.Add("TS", 19);
+
+            
+            // JIS PLACES
+
+            jisPlaces.Add("A1", 20);
+            jisPlaces.Add("A2-Hlavni vchod", 20);
+            jisPlaces.Add("A2", 20);
+            jisPlaces.Add("A3", 20);
+            jisPlaces.Add("B3", 21);
+            jisPlaces.Add("B3-LEVY", 21);
+            jisPlaces.Add("B3-LevyVytah", 21);
+            jisPlaces.Add("B3-PRAVY", 21);
+            jisPlaces.Add("B3-PravyVytah", 21);
+            jisPlaces.Add("M16", 21);
+            jisPlaces.Add("M14", 21);
+            jisPlaces.Add("L1", 22);
+            jisPlaces.Add("L2", 22);
+            jisPlaces.Add("L1L2-vchod", 22);
+            jisPlaces.Add("L-Posilovna", 22);
+            jisPlaces.Add("K1", 23);
+            jisPlaces.Add("KL-Posilovna", 23);
+
+            jisPlaces.Add("MenzaKL-vydej", 5);
+            jisPlaces.Add("Menza4-kasa1", 5);
+            jisPlaces.Add("Menza4-kasa2", 5);
+            jisPlaces.Add("Menza4-kasa3", 5);
+            jisPlaces.Add("Menza4-kasa4", 5);
+            jisPlaces.Add("Menza4-kasa5", 5);
+            jisPlaces.Add("Menza-kasa-1", 5);
+            jisPlaces.Add("Menza-kasa-p", 5);
+            jisPlaces.Add("Menza1-kasa-p", 5);
+            jisPlaces.Add("Menza1-kasa-l", 5);
+            
+            jisPlaces.Add("NTIS-BUFET", 2);
+            jisPlaces.Add("EP-BUFET", 3);
+            jisPlaces.Add("UV1-Bufet", 0);
+
+            // bikes
+            jisPlaces.Add("EXT/kola-B", 2);
+            jisPlaces.Add("EXT/kola", 0);
+            jisPlaces.Add("B3-kolarna", 21);
+            jisPlaces.Add("KolaBory-vnejsi", 0);
+            jisPlaces.Add("KolaBory-vnitrni", 0);
+
+            //
+            jisPlaces.Add("Parkoviste-vjezd", -1);
+            jisPlaces.Add("Parkoviste-vyjezd", -1);
+            jisPlaces.Add("VC-VJEZD", 17);
+            jisPlaces.Add("VC-VYJEZD", 17);
+
+            //
+            //jisPlaces.Add("Zavora-Kaplirova", );
+            jisPlaces.Add("Zavora-FEL", 3);
+            jisPlaces.Add("US 005 - závora vjezd", 2);
+            jisPlaces.Add("US 005 - mříž vjezd", 2);
+            jisPlaces.Add("Zavora-NTIS-vjezd", 2);
+            jisPlaces.Add("Zavora-NTIS-vyjezd", 2);
+            jisPlaces.Add("Zavora-FDU", 1);
+
+            // Studies
+            jisPlaces.Add("STUD_UB113", 6);
+            jisPlaces.Add("STUD_UB211", 6);
+            jisPlaces.Add("STUD_VC53", 17);
+            jisPlaces.Add("STUD_KL20", 13);
+            jisPlaces.Add("STUD_KL87", 13);
+            //jisPlaces.Add("STUD_CHEB", );
+            jisPlaces.Add("STUD_PRA1", 9);
             jisPlaces.Add("STUD_ST407", 4);
         }
 