commit abfd9c7c7b74c2d2e7eae3b10439ce414823f399
Author: Roman Kalivoda <kalivodaroman@gmail.com>
Date:   Thu Apr 15 16:38:04 2021 +0200

    Add packages.config, add Predictors
    
    Stub model component

diff --git a/Server/ServerApp/Predictor/IPredictor.cs b/Server/ServerApp/Predictor/IPredictor.cs
new file mode 100644
index 0000000..8db9f0a
--- /dev/null
+++ b/Server/ServerApp/Predictor/IPredictor.cs
@@ -0,0 +1,18 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using Microsoft.ML;
+using Microsoft.ML.Data;
+
+namespace ServerApp.Predictor
+{
+    interface IPredictor
+    {
+
+        void Fit(ModelInput trainInput);
+
+        void Predict(ModelInput testInput);
+    }
+}
diff --git a/Server/ServerApp/Predictor/ModelInput.cs b/Server/ServerApp/Predictor/ModelInput.cs
new file mode 100644
index 0000000..d281b40
--- /dev/null
+++ b/Server/ServerApp/Predictor/ModelInput.cs
@@ -0,0 +1,12 @@
+﻿namespace ServerApp.Predictor
+{
+    public class ModelInput
+    {
+        protected class DataPoint
+        {
+            public uint Label { get; set; }
+
+            public float[] Features { get; set; }
+        }
+    }
+}
\ No newline at end of file
diff --git a/Server/ServerApp/Predictor/NaiveBayesClassifier.cs b/Server/ServerApp/Predictor/NaiveBayesClassifier.cs
new file mode 100644
index 0000000..218ca58
--- /dev/null
+++ b/Server/ServerApp/Predictor/NaiveBayesClassifier.cs
@@ -0,0 +1,30 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using Microsoft.ML;
+
+namespace ServerApp.Predictor
+{
+    class NaiveBayesClassifier : IPredictor
+    {
+        private MLContext mlContext;
+
+        public NaiveBayesClassifier()
+        {
+            mlContext = new MLContext();
+
+        }
+
+        public void Fit(ModelInput trainingData)
+        {
+            throw new NotImplementedException();
+        }
+
+        public void Predict(ModelInput testData)
+        {
+            throw new NotImplementedException();
+        }
+    }
+}
diff --git a/Server/ServerApp/ServerApp.csproj b/Server/ServerApp/ServerApp.csproj
index 41ae389..32aab27 100644
--- a/Server/ServerApp/ServerApp.csproj
+++ b/Server/ServerApp/ServerApp.csproj
@@ -43,6 +43,9 @@
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Predictor\IPredictor.cs" />
+    <Compile Include="Predictor\ModelInput.cs" />
+    <Compile Include="Predictor\NaiveBayesClassifier.cs" />
     <Compile Include="obj\Debug\.NETFramework,Version=v4.7.2.AssemblyAttributes.cs" />
     <Compile Include="Parser\InputData\CsvDataLoader.cs" />
     <Compile Include="Parser\InputData\JisInstance.cs" />
diff --git a/Server/ServerApp/packages.config b/Server/ServerApp/packages.config
new file mode 100644
index 0000000..dc4d10d
--- /dev/null
+++ b/Server/ServerApp/packages.config
@@ -0,0 +1,16 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<packages>
+  <package id="Microsoft.ML" version="1.5.5" targetFramework="net472" />
+  <package id="Microsoft.ML.CpuMath" version="1.5.5" targetFramework="net472" />
+  <package id="Microsoft.ML.DataView" version="1.5.5" targetFramework="net472" />
+  <package id="Newtonsoft.Json" version="10.0.3" targetFramework="net472" />
+  <package id="System.Buffers" version="4.4.0" targetFramework="net472" />
+  <package id="System.CodeDom" version="4.4.0" targetFramework="net472" />
+  <package id="System.Collections.Immutable" version="1.5.0" targetFramework="net472" />
+  <package id="System.Memory" version="4.5.3" targetFramework="net472" />
+  <package id="System.Numerics.Vectors" version="4.4.0" targetFramework="net472" />
+  <package id="System.Reflection.Emit.Lightweight" version="4.3.0" targetFramework="net472" />
+  <package id="System.Runtime.CompilerServices.Unsafe" version="4.5.3" targetFramework="net472" />
+  <package id="System.Threading.Channels" version="4.7.1" targetFramework="net472" />
+  <package id="System.Threading.Tasks.Extensions" version="4.5.4" targetFramework="net472" />
+</packages>
\ No newline at end of file